package com.xhkjedu.sexam.controller.exam;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.xhkjedu.sexam.model.exam.ESubjectBadstudent;
import com.xhkjedu.sexam.service.exam.ESubjectBadstudentService;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.utils.PageUtil;
import com.xhkjedu.vo.PageResult;
import com.xhkjedu.vo.ResultVo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/ebs")
public class ESubjectBadstudentController {
    @Resource
    private ESubjectBadstudentService eSubjectBadstudentService;

    /**
     * 保存违规学生记录
     *
     * @return com.xhkjedu.vo.ResultVo
     * @Param [badstudent]
     * @Author ywx
     * @Date 2022/8/17 10:50
     **/
    @PostMapping("/add")
    public ResultVo add(@RequestBody ESubjectBadstudent badstudent) {
        N_Utils.validation(new Object[]{badstudent.getStudentid(), "学生id", 1, badstudent.getEsid(), "考试科目id", 1
                , badstudent.getClassid(), "班级id", 1, badstudent.getExamid(), "考试id", 1
                , badstudent.getBadtype(), "违规类型", 1
        });
        eSubjectBadstudentService.save(badstudent);
        return new ResultVo(0, "保存成功");
    }

    /**
     * 实时监控
     *
     * @return com.xhkjedu.vo.ResultVo
     * @Param [badstudent]
     * @Author ywx
     * @Date 2022/8/17 11:44
     **/
    @PostMapping("/list_sjk")
    public ResultVo listJk(@RequestBody ESubjectBadstudent badstudent) {
        Integer examid = badstudent.getExamid();
        Integer esid = badstudent.getEsid();
        Integer classid = badstudent.getClassid();
        Integer page = badstudent.getPage();
        Integer pageSize = badstudent.getPageSize();
        N_Utils.validation(new Object[]{examid, "考试id", 1, page, "页码", 1, pageSize, "显示条数", 1});
        PageHelper.startPage(page, pageSize);
        List<Map> list = eSubjectBadstudentService.listStu(esid, classid, badstudent.getCreatename());
        PageResult pageResult = PageUtil.getPageResult(new PageInfo<>(list));
        Map map = eSubjectBadstudentService.getJkDetail(examid, esid);
        map.put("pageResult", pageResult);
        return new ResultVo(0, "获取成功", map);
    }
}
